import '../field/dfbasefield.dart';
import 'dfqueryentityjoin.dart';
import 'dfquerycriteriagroup.dart';
import 'dfqueryorderby.dart';
import 'dfquerypaging.dart';
import 'dfquery.dart';
import 'package:meta/meta.dart';

class DfSyncQuery extends DfQuery {
  
  Map<DfBaseField, dynamic> onlineFields;
  DfQueryEntityJoin onlineEntityJoin;

  DfSyncQuery({@required DfQueryPurpose purpose, @required dynamic queryFields, @required dynamic onlineQueryFields, @required DfQueryEntityJoin entityJoin, @required this.onlineEntityJoin, DfQueryCriteriaGroup criteriaGroup, List<DfQueryOrderBy> orderBy, List<DfBaseField> groupBy, Paging paging}) : super(purpose: purpose, queryFields: queryFields, entityJoin: entityJoin, criteriaGroup: criteriaGroup, orderBy: orderBy, groupBy: groupBy, paging: paging) {
    if (onlineQueryFields is Map) {
      onlineFields = onlineQueryFields;  
    }
    else {
      onlineFields = Map<DfBaseField, dynamic>();
      List<DfBaseField> arrFields = onlineQueryFields;
      arrFields.forEach((field) => onlineFields[field] = null);
    }
  }

}

